#include<iostream>
#include<fstream>
#include<string.h>
#include"BWT.cc"
#include"MTF.cc"
#include"huffman.cc"

#define DATA 20*1024

using namespace std;



int main(int argc, char *argv[]){
  unsigned char Ft[DATA],CODE[DATA];
  int len=0;
  char c;
  //char filename[256];
  int count = 0,Ans;

  //cout << "please input filename:";
  //cin >> filename;  
  //cout << "(" << filename << ")" << endl << endl;



  ifstream in(argv[1],ios::binary);
  if(!in)
    {cout << "Error! No File:" << argv[1] << endl;}

  while(in.read(&c,1) != 0){
    Ft[len]=c;
    len++;
    //int d = c;
    //cout << d << " " <<sizeof(c) << endl;
  }

  cout << "decode or encode? (if decode:0 else encode:1)" <<endl;
  cout << "enter which key :";
  cin  >> Ans;


  if(Ans==1){
    int *p =&len;
    BWT_enc(Ft,p);
 
    mtf_encode(Ft,p);

    long l = enHuffman(CODE,DATA,Ft,len);

    if(l!=-1L){

      ofstream out(argv[2],ios::binary);

      int co=0;
      while(co < l){

	out.put(CODE[co]);
	co++;
      }
    } 

  }

  else if(Ans==0){


    long f = deHuffman(CODE,DATA,Ft,len);

    //dbug
    //cout <<"f:"<< f <<endl;
    //for(int p=0;p<(f & 0xFFFFFFFF);p++)
    //  {cout << int(CODE[p])<<" ";}
    //cout << endl;
    //

    if(f!=-1L){
      int h = f & 0xFFFFFFFF;
      int *po=&h;
      mtf_decode(CODE,po);
      BWT_dec(CODE,po);

      ofstream d_out(argv[2],ios::binary);

      int co=0;
      while(co < h){

	d_out.put(CODE[co]);
	co++;
	
      }
      
      }
 
  return 0;
  }
}


